#include <stdio.h>
#include <string.h>

#include "SVBCameraSDK.h"

#include <assert.h>

int main()
{
	int cameraNum = SVBGetNumOfConnectedCameras();

	SVB_ERROR_CODE ret;
	int cameraID = -1;
	for (int i = 0; i < cameraNum; i++)
	{
		SVB_CAMERA_INFO cameraInfo;
		ret = SVBGetCameraInfo(&cameraInfo, i);
		if (ret == SVB_SUCCESS)
		{
			printf("Friendly name: %s\r\n", cameraInfo.FriendlyName);
			cameraID = cameraInfo.CameraID;
		}
	}

	if (cameraID == -1)
		return -1;

	//////////////////////////////////////
	// open the camera
	ret = SVBOpenCamera(cameraID);
	if (ret != SVB_SUCCESS)
	{
		printf("open camera failed.\r\n");
		return -1;
	}

	ret = SVBSetCameraMode(cameraID, SVB_MODE_NORMAL);
	assert(ret == SVB_SUCCESS);

	ret = SVBSetOutputImageType(cameraID, SVB_IMG_Y8);
    	if(ret != SVB_SUCCESS)
    	{
        	printf("camera set frame format failed\r\n");
        	return -1;
    	}

	////////////////////////////////////////////////////////////////
	// start video capture
	ret = SVBStartVideoCapture(cameraID);
	assert(ret == SVB_SUCCESS);

	/////////////////////////////////////////////////////////////
	int bufferSize = 1920 * 1080;
	unsigned char *pBuffer = new unsigned char[bufferSize];

	ret = SVBGetVideoData(cameraID, pBuffer, bufferSize, 100);
	if (ret != SVB_SUCCESS)
		return -1;
	char path[256];
	sprintf(path, "SVB_image_normal.pgm");
	FILE *fp = NULL;
	fp = fopen(path, "w");
	if (fp == NULL)
	{
		printf("open file %s failed\r\n", path);
		return -1;
	}
	fprintf(fp, "P5\n#\n1920 1080\n255\n");
	fwrite(pBuffer, bufferSize, 1, fp);
	fclose(fp);
	printf("write image file %s\r\n", path);

	/////////////////////////////////////////////////////////////
	// stop video capture
	printf("stop camera capture\r\n");
	ret = SVBStopVideoCapture(cameraID);
	assert(ret == SVB_SUCCESS);

	printf("close camera\r\n");
	SVBCloseCamera(cameraID);

	getchar();
    return 0;
}
